#!/usr/bin/perl -w 

@number_of_threads = (1,  2, 3, 4, 5, 6, 8, 10,15, 20,40,60,80, 100,150, 200,300);
@time_limit        = (10,20,20,20,20,20,20, 30,30, 50,50,50,50, 100,100, 200,200);

if ($#ARGV != 0) {
 print STDERR "Usage: run_experiments.pl <output_file>\n";
 exit(1);
}

open(OUTPUT,"> $ARGV[0]");
print OUTPUT    " nThreads time avgFlops sumFlops minFlops maxFlops \n";

open(RAWOUTPUT,"> raw.single.data");
print RAWOUTPUT " nThreads threadId flops time\n";

$count= 0;

$max  = 0;
$min  = 999999999;

$sumFlops = 0;
$avgFlops = 0;

for ($i=0;$i<=$#number_of_threads;$i++) {
  open(FD, "./cpu_sharing $number_of_threads[$i] $time_limit[$i] |");
  $sumFlops = 0;
  $avgFlops = 0;
  for ($j=0;$j<$number_of_threads[$i];$j++) {
    $value = <FD>;
    chop($value);
    $sumFlops+=$value;
    if($value > $max) { $max = $value; }
    if($value < $min) { $min = $value; }
    $count++;
    print RAWOUTPUT " $count ".$number_of_threads[$i]." $j $value ".$time_limit[$i]."\n";
  }
  $avgFlops = ($sumFlops/$number_of_threads[$i])/$time_limit[$i];
  $sumFlops = $sumFlops/$time_limit[$i];
  print OUTPUT "$count ".$number_of_threads[$i]." ".$time_limit[$i]." $avgFlops $sumFlops $min $max\n";
  close(FD);
}


close(OUTPUT);
close(RAWOUTPUT);


