#!/usr/bin/perl -w 

#@number_of_threads = (1, 2, 3, 4, 5, 6, 8, 10,15,20, 40, 60, 80, 100,150,200,300,400,500, 750, 1000, 1500, 2000, 2500, 3000, 3500);
#@time_limit        = (10,20,20,20,20,20,20,30,30,50, 50, 50, 50, 100,100,200,200,300,300, 400, 500,  700,  800,  900,  1000,  1000);

@number_of_threads = (1, 2, 3, 4, 5, 6, 8, 10,15,20, 40, 60, 80, 100,150,200,300,400,500,600,800, 1000);
@time_limit        = (10,20,20,20,20,20,20,30,30,50, 50, 50, 50, 100,100,200,200,300,400,500,600, 700);

if ($#ARGV != 0) {
 print STDERR "Usage: run_experiments.pl <output_file>\n";
 exit(1);
}

open(OUTPUT,"> $ARGV[0]");

print OUTPUT "hold on;\n";

$count=0;
$x =();
$y =();
for ($i=0;$i<=$#number_of_threads;$i++) {
  open(FD, "./cpu_sharing_memory $number_of_threads[$i] $time_limit[$i] |");
  $sum = 0;
  for ($j=0;$j<$number_of_threads[$i];$j++) {
    $value = <FD>;
    chop($value);
    $x[$count]=$number_of_threads[$i];
    $y[$count]=$value / $time_limit[$i];
    $sum += $y[$count];
    $count++;
  }
  $averages[$i] = $sum / $number_of_threads[$i];
  close(FD);
}

# Plotting the average
#
print OUTPUT "semilogy([";
for ($i=0;$i<=$#number_of_threads-1;$i++) {
  print OUTPUT $number_of_threads[$i].",";
}
print OUTPUT $number_of_threads[$i];
print OUTPUT "],[";
for ($i=0;$i<=$#number_of_threads-1;$i++) {
  print OUTPUT $averages[$i].",";
}
print OUTPUT $averages[$i];
print OUTPUT "]);\n";

# Plotting the ideal
#
print OUTPUT "semilogy([";
for ($i=0;$i<=$#number_of_threads-1;$i++) {
  print OUTPUT $number_of_threads[$i].",";
}
print OUTPUT $number_of_threads[$i];
print OUTPUT "],[";
for ($i=0;$i<=$#number_of_threads-1;$i++) {
  print OUTPUT ($averages[0]/($number_of_threads[$i])).",";
}
print OUTPUT ($averages[0]/($number_of_threads[$i]));
print OUTPUT "]);\n";

# Plotting the full value
#
print OUTPUT "x = [";
for ($i=0;$i<$count-1;$i++) {
  print OUTPUT $x[$i].",";
}
print OUTPUT $x[$i]."];\n";
print OUTPUT "y = [";
for ($i=0;$i<$count-1;$i++) {
  print OUTPUT $y[$i].",";
}
print OUTPUT $y[$i]."];\n";
print OUTPUT "semilogy(x,y,'+');\n";

print OUTPUT "pause;\n";

close(OUTPUT);



